move some stuff to frodo, rename user to iank, fixes
[distro-setup] / mount-latest-subvol
index 73709316d39b79dac8865aef265b0496574d0fc2..e4c4d6b0a652b992f6feb7483cecd394bbf1040c 100644 (file)
@@ -1,4 +1,19 @@
 #!/bin/bash
+# Copyright (C) 2016 Ian Kelling
+#
+# Licensed under the Apache License, Version 2.0 (the "License");
+# you may not use this file except in compliance with the License.
+# You may obtain a copy of the License at
+#
+#     http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing, software
+# distributed under the License is distributed on an "AS IS" BASIS,
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+# See the License for the specific language governing permissions and
+# limitations under the License.
+
+# usage: mount-latest-subvol
 
 [[ $EUID == 0 ]] || exec sudo -E "$BASH_SOURCE" "$@"
 
@@ -17,7 +32,7 @@ errcatch() {
     set -o pipefail
 }
 bash-trace() {
-    local -i argc_index=0 arg frame i start=${1:-1} max_indent=8 indent
+    local -i argc_index=0 frame i start=${1:-1} max_indent=8 indent
     local source
     local extdebug=false
     if [[ $(shopt -p extdebug) == *-s* ]]; then
@@ -53,7 +68,7 @@ tu() {
 e() { printf "%s\n" "$*"; "$@"; }
 mnt() {
     dir=$1
-    if ! mountpoint $dir >/dev/null; then
+    if ! mountpoint $dir &>/dev/null; then
         mkdir -p $dir
         e mount $dir
     fi
@@ -61,49 +76,65 @@ mnt() {
 
 ret=0
 
+##### begin setup fstab for subvols we care about ######
 first_root_crypt=$(awk '$2 == "/" {print $1}' /etc/mtab)
 tu /etc/fstab <<EOF
-$first_root_crypt  /q  btrfs  noatime,subvol=q  0 0
-/q/a  /a  none  bind  0 0
+$first_root_crypt  /a  btrfs  noatime,subvol=a  0 0
 EOF
 case $HOSTNAME in
     treetowl|x2|frodo)
         tu /etc/fstab <<EOF
-$first_root_crypt  /p  btrfs  noatime,subvol=p  0 0
+$first_root_crypt  /q  btrfs  noatime,subvol=q  0 0
+$first_root_crypt  /o  btrfs  noatime,subvol=o  0 0
+/q/p  /p  none  bind  0 0
+/o/m  /m  none  bind  0 0
 EOF
         ;;
 esac
+if [[ $HOSTNAME == frodo ]]; then
+    tu /etc/fstab <<EOF
+$first_root_crypt  /i  btrfs  noatime,subvol=i  0 0
+EOF
+fi
+##### end setup fstab for subvols we care about ######
 
-for vol in q p; do
+for vol in q a o i; do
     d=/$vol
     if ! awk '{print $2}' /etc/fstab | grep -xF $d &>/dev/null; then
         continue
     fi
 
 
-    binds=()
-    roots=($d)
+    ##### begin building up list of bind mounts  ######
+    binds=() # list of bind mounts
+    roots=($d) # list of bind mounts, plus the original mount
     while true; do
         new_roots=()
         for r in ${roots[@]}; do
-            # /q/a  /a  none  bind  0 0
+            # eg. when r=/q/p, for lines like
+            # /q/p  /p  none  bind  0 0
+            # output /p
             new_roots+=($(sed -rn "s#^$r/\S+\s+(\S+)\s+none\s+bind\s.*#\1#p" /etc/fstab))
         done
         (( ${#new_roots} )) || break
         binds+=(${new_roots[@]})
         roots=( ${new_roots[@]} )
     done
+    ##### end building up list of bind mounts  ######
 
+
+    # if latest is already mounted, make sure binds are mounted and move on
     if e check-subvol-stale $d; then
+        mnt $d
         for b in ${binds[@]}; do
             mnt $b
         done
         continue
     fi
 
-    last_snap=$(</nocow/btrfs-stale/$vol)
-    if [[ ! $last_snap ]]; then
-        echo "$0: error. empty last_snap var"
+    fresh_snap=$(</nocow/btrfs-stale/$vol)
+    if [[ ! $fresh_snap ]]; then
+        echo "$0: error. empty fresh_snap var"
         ret=1
         continue
     fi
@@ -115,9 +146,23 @@ for vol in q p; do
             if e umount -R $dir; then
                 unmounted+=($dir)
             else
-                umount_ret=false
                 echo "$0: failed to umount $dir"
-                break
+                # lsof will fail if it finds no pids
+                if ! e lsof $dir; then
+                    umount_ret=false
+                    ret=1
+                    continue
+                fi
+                pids=$(lsof -t $dir) ||:
+                kill $pids
+                sleep .5
+                if e umount -R $dir; then
+                    unmounted+=($dir)
+                else
+                    umount_ret=false
+                    ret=1
+                    continue
+                fi
             fi
         fi
     done
@@ -126,24 +171,27 @@ for vol in q p; do
         for dir in ${unmounted[@]}; do
             mnt $dir
         done
-        ret=1
         continue
     fi
 
+    # todo: decipher /mnt/root, like we do in check-subvol-stale
     cd /mnt/root
     if [[ -e $vol ]]; then
-        e btrfs sub del $vol
+        e mv $vol $vol.leaf.$(date +%Y%m%dT%H%M%S%z)
     fi
     # Note, we make a few assumptions in this script, like
     # $d was not a different subvol id than $vol, and
     # things otherwise didn't get mounted very strangely.
-    e btrfs sub snapshot btrbk/$last_snap $vol
+    e btrfs sub snapshot $fresh_snap $vol
     for dir in $d ${binds[@]}; do
         e mnt $dir
     done
+    stale_dir=/nocow/btrfs-stale
+    rm -f $stale_dir/$d
 done
 
-if [[ $HOSTNAME == treetowl ]]; then
+### disabled
+if [[ $HOSTNAME == treetowlxxxxxxxxx ]]; then
     # partitioned it with fai partitioner outside of fai,
     # because it\'s worth it to have 1% space reserved for boot and
     # swap partitions in case I ever want to boot off those drives.
@@ -178,10 +226,8 @@ EOF
             cryptdisks_start crypt_dev_$dev
         fi
     done
-else
-    tu /etc/fstab <<'EOF'
-/q/i  /i  none  bind,noauto  0 0
-EOF
+    # note, could do an else here and have some kind of mount for /i
+    # on other hosts.
 fi
 
 exit $ret